﻿using System.Windows;
using System.Collections.ObjectModel;

namespace InfraTestBase
{
    /// <summary>
    /// Interaction logic for OutlookBar1.xaml
    /// </summary>
    public partial class OutlookBar1 : Window
    {
        private ObservableCollection<TaskGroup> _taskGroups;

        public OutlookBar1()
        {
            InitializeComponent();
            this.DataContext = this.TaskGroups;
        }

        // Property that returns a collection Of TaskGroup objects
        public ObservableCollection<TaskGroup> TaskGroups
        {
            get
            {
                // If we haven't yet created and populated the collection of TaskGroup objects, create and populate it now.
                if (this._taskGroups == null)
                {
                    this._taskGroups = new ObservableCollection<TaskGroup>();

                    TaskGroup taskgroup1 = new TaskGroup("TaskGroup1", @"/;component/images/icons/XamOutlookBar/OBarTeamTasks.png");
                    Task task1 = new Task("Task1", @"/;component/images/icons/XamOutlookBar/OBarCreateNew.png");
                    task1.TaskItems.Add(new TaskItem("TaskItem1", @"/;component/images/icons/XamOutlookBar/OBarCreateNew.png"));
                    task1.TaskItems.Add(new TaskItem("TaskItem2", @"/;component/images/icons/XamOutlookBar/OBarCreateNew.png"));
                    taskgroup1.Tasks.Add(task1);

                    this._taskGroups.Add(taskgroup1);

                    TaskGroup taskgroup2 = new TaskGroup("TaskGroup1", @"/;component/images/icons/XamOutlookBar/OBarTeamTasks.png");
                    Task task2 = new Task("Task1", @"/;component/images/icons/XamOutlookBar/OBarCreateNew.png");
                    task2.TaskItems.Add(new TaskItem("TaskItem1", @"/;component/images/icons/XamOutlookBar/OBarCreateNew.png"));
                    task2.TaskItems.Add(new TaskItem("TaskItem2", @"/;component/images/icons/XamOutlookBar/OBarCreateNew.png"));
                    taskgroup2.Tasks.Add(task2);

                    this._taskGroups.Add(taskgroup2);
                }


                return this._taskGroups;
            }
        }
    }

    // The TaskGroup class definition.
    public class TaskGroup
    {
        // Member variable that stores a reference to a collection of TaskGroup objects.
        private ObservableCollection<Task> _tasks;

        public TaskGroup(string title, string image)
        {
            this.Title = title;
            this.Image = image;
        }

        // Properties that return the Title and Image associated with the TaskGroup.
        public string Title { get; set; }
        public string Image { get; set; }


        // Property that returns a collection of Task objects
        public ObservableCollection<Task> Tasks
        {
            get
            {
                // If we haven't yet created the collection of Task objects, create it now.
                if (this._tasks == null)
                    this._tasks = new ObservableCollection<Task>();

                return this._tasks;
            }
        }
    }

    // The Task class definition.
    public class Task
    {
        private ObservableCollection<TaskItem> _taskitems;

        public Task(string text, string image)
        {
            this.Text = text;
            this.Image = image;
        }

        // Properties that return the Text and Image associated with the TaskGroup.
        public string Text { get; set; }
        public string Image { get; set; }

        // Property that returns a collection of Task objects
        public ObservableCollection<TaskItem> TaskItems
        {
            get
            {
                // If we haven't yet created the collection of Task objects, create it now.
                if (this._taskitems == null)
                    this._taskitems = new ObservableCollection<TaskItem>();

                return this._taskitems;
            }
        }
    }

    // The Taskitem class definition.
    public class TaskItem
    {
        public TaskItem(string text, string image)
        {
            this.Text = text;
            this.Image = image;
        }

        // Properties that return the Text and Image associated with the TaskGroup.
        public string Text { get; set; }
        public string Image { get; set; }
    }
}
